Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.jdo
Class TransactionAwarePersistenceManagerFactoryProxy

    java.lang.Object
      org.springframework.orm.jdo.TransactionAwarePersistenceManagerFactoryProxy

All Implemented Interfaces:
  FactoryBean

    public class TransactionAwarePersistenceManagerFactoryProxy

extends Object
implements FactoryBean

Proxy for a target JDO `PersistenceManagerFactory`, returning the current thread-bound PersistenceManager (the Spring-managed transactional PersistenceManager or a the single OpenPersistenceManagerInView PersistenceManager) on `getPersistenceManager()`, if any.

Essentially, `getPersistenceManager()` calls get seamlessly forwarded to `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`. Furthermore, `PersistenceManager.close` calls get forwarded to `PersistenceManagerFactoryUtils.releasePersistenceManager(javax.jdo.PersistenceManager, javax.jdo.PersistenceManagerFactory)`.

The main advantage of this proxy is that it allows DAOs to work with a plain JDO PersistenceManagerFactory reference, while still participating in Spring's (or a J2EE server's) resource and transaction management. DAOs will only rely on the JDO API in such a scenario, without any Spring dependencies.

Note that the behavior of this proxy matches the behavior that the JDO spec defines for a PersistenceManagerFactory as exposed by a JCA connector, when deployed in a J2EE server. Hence, DAOs could seamlessly switch between a JNDI PersistenceManagerFactory and this proxy for a local PersistenceManagerFactory, receiving the reference through Dependency Injection. This will work without any Spring API dependencies in the DAO code!

It is usually preferable to write your JDO-based DAOs with Spring's `JdoTemplate`, offering benefits such as consistent data access exceptions instead of JDOExceptions at the DAO layer. However, Spring's resource and transaction management (and Dependency Injection) will work for DAOs written against the plain JDO API as well.

Of course, you can still access the target PersistenceManagerFactory even when your DAOs go through this proxy, by defining a bean reference that points directly at your target PersistenceManagerFactory bean.

Since:
  1.2
Author:
  Juergen Hoeller
See Also:
  `PersistenceManagerFactory.getPersistenceManager()`, `PersistenceManager.close()`, `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`, `PersistenceManagerFactoryUtils.releasePersistenceManager(javax.jdo.PersistenceManager, javax.jdo.PersistenceManagerFactory)`

Constructor Summary
`TransactionAwarePersistenceManagerFactoryProxy()`

Method Summary
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`javax.jdo.PersistenceManagerFactory` | `getTargetPersistenceManagerFactory()` Return the target JDO PersistenceManagerFactory that this proxy delegates to.
`protected boolean` | `isAllowCreate()` Return whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`void` | `setAllowCreate(boolean allowCreate)` Set whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.
`void` | `setTargetPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory target)` Set the target JDO PersistenceManagerFactory that this proxy should delegate to.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TransactionAwarePersistenceManagerFactoryProxy

    public TransactionAwarePersistenceManagerFactoryProxy()

Method Detail

### setTargetPersistenceManagerFactory

    public void setTargetPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory target)

  Set the target JDO PersistenceManagerFactory that this proxy should delegate to. This should be the raw PersistenceManagerFactory, as accessed by JdoTransactionManager.

  See Also:
    `JdoTransactionManager`

### getTargetPersistenceManagerFactory

    public javax.jdo.PersistenceManagerFactory getTargetPersistenceManagerFactory()

  Return the target JDO PersistenceManagerFactory that this proxy delegates to.

### setAllowCreate

    public void setAllowCreate(boolean allowCreate)

  Set whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.

  Default is "true". Can be turned off to enforce access to transactional PersistenceManagers, which safely allows for DAOs written to get a PersistenceManager without explicit closing (i.e. a `PersistenceManagerFactory.getPersistenceManager()` call without corresponding `PersistenceManager.close()` call).

  See Also:
    `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`

### isAllowCreate

    protected boolean isAllowCreate()

  Return whether the PersistenceManagerFactory proxy is allowed to create a non-transactional PersistenceManager when no transactional PersistenceManager can be found for the current thread.

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.